var Login = function()
{
	var login = {};
	var debug = 0;
	
	login.initPage = function()
	{
		
		Events.doOnEnter('yubikey', login.doLogin);
		Buttons.addClickHandler('btnLogin', login.doLogin);
		
		Events.addEventHandler('username', 'keyup', login.inputOnChange);
		Events.addEventHandler('password', 'keyup', login.inputOnChange);
		Events.addEventHandler('yubikey', 'keyup', login.inputOnChange);
		
		var username = Doc.element('username');
		if (!username.value)
		{
			username.focus();
		}
		else
		{
			Doc.addClass('username', 'not-empty');
			Doc.element('password').focus();
		}
	}

	login.inputOnChange = function(event)
	{
		Doc.removeClass(event.currentTarget, 'not-valid');
		Doc.addOrRemoveClass(event.currentTarget, 'not-empty', event.currentTarget.value);
	}
	
	login.doLogin = function()
	{
		var username = Doc.element('username');
		var password = Doc.element('password');
		var yubikey = Doc.element('yubikey');
		
		var msg;
		var focusElement = null;
		if (!yubikey.value) 
		{
			Doc.addClass(yubikey, 'not-valid');
			msg = 'Koppla in din YubiKey i datorn och tryck på knappen!';
			focusElement = yubikey;
		}
		if (!password.value) 
		{
			Doc.addClass(password, 'not-valid');
			msg = 'Skriv in ditt lösenord!';
			focusElement = password;
		}
		if (!username.value) 
		{
			Doc.addClass(username, 'not-valid');
			msg = 'Du måste ange ditt användarnamn!';
			focusElement = username;
		}
		
		if (focusElement) focusElement.focus();
		Doc.element('message').innerHTML = msg || 'Loggar in...';
		if (msg) return;
		
		
		var submitInfo = {};
		submitInfo.username = username.value;
		submitInfo.password = password.value;
		submitInfo.yubikey = yubikey.value;
		
		yubikey.value = '';
		
		var url = '../Delivery.servlet';
		url += '?cmd=Login';
		
		Wizard.asyncJsonRequest(url, login.whenLoggedIn, 'POST', JSON.stringify(submitInfo), login.whenLoginFailed);
	}
	
	login.whenLoginFailed = function(response, error)
	{
		if (debug) 
		{
			App.debug(response);
			App.debug(error);
		}
		
		var err = login.translateError(response ? response.message : error.toString());
		if (err.focusElement)
		{
			Doc.addClass(err.focusElement, 'not-valid');
			Doc.element(err.focusElement).focus();
			Doc.element(err.focusElement).select();
		}
		
		var msg = 'Det gick inte att logga in!';
		msg += '<div class="login-failed" title="'+Strings.encodeTags(err.originalMessage)+'">';
		msg += Strings.encodeTags(err.message)+'</div>';
		
		Doc.element('message').innerHTML = msg;		
	}
	
	login.whenLoggedIn = function(response)
	{
		location.href = 'list.jsp?ID='+response.ID;
	}
	
	/**
		Translate some common error messages to Swedish. Returns an object with
		* originalMessage: The original error message
		* message: The translated error message (or the original if no translation was found
		* focusElement: The element in the login form that is not valid
	 */
	login.translateError = function(message)
	{
		var err = {};
		err.originalMessage = message;
		err.message = message;
		
		if (message.indexOf('Invalid YubiKey') >= 0 || message.indexOf('BAD_OTP') >= 0)
		{
			err.message = 'Ogiltigt YubiKey lösenord';
			err.focusElement = 'yubikey';
		}
		else if (message.indexOf('REPLAYED_OTP') >= 0)
		{
			err.message = 'YubiKey lösenordet har redan använts';
			err.focusElement = 'yubikey';
		}
		else if (message.indexOf('Unknown username') >= 0)
		{
			err.message = 'Okänt användarnamn';
			err.focusElement = 'username';
		}
		else if (message.indexOf('YubiKey doesn\'t belong to user') >= 0)
		{
			err.message = 'YubiKey:n hör inte ihop med den här användaren';
			err.focusElement = 'username';
		}
		else if (message.indexOf('flagged for deletion') >= 0 || 
				message.indexOf('is disabled') >=0 ||
				message.indexOf('account has expired') >= 0)
		{
			err.message = 'Användarkontot har upphört att gälla';
			err.focusElement = 'username';
		}
		else if (message.indexOf('password for login') >= 0)
		{
			err.message = 'Felaktigt lösenord';
			err.focusElement = 'password';
		}
		else if (message.indexOf('Not allowed to use Client') >= 0)
		{
			err.message = 'Åtkomst nekad';
			err.focusElement = 'username';
		}
		
		return err;
	}
	
	return login;
}();

Doc.onLoad(Login.initPage);